﻿using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
using AddinExpress.MSO;
using Outlook = Microsoft.Office.Interop.Outlook;

namespace MainAddIn
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("762751A6-81C2-4CBB-8547-9064293454E1"), ProgId("MainAddIn.AddinModule")]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule()
        {
            Application.EnableVisualStyles();
            InitializeComponent();
            // Please add any initialization code to the AddinInitialize event handler
        }

        private ADXRibbonTab adxRibbonTab1;
        private ADXRibbonGroup adxRibbonGroup1;
        private ADXRibbonCheckBox enableContactsRibbonCheckBox;
        private ADXRibbonCheckBox enableTasksRibbonCheckBox;
        private ADXAddinAdditionalModuleItem tasksAddinAdditionalModuleItem;
        private ADXAddinAdditionalModuleItem contactsAddinAdditionalModuleItem;

        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;

        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            this.adxRibbonTab1 = new AddinExpress.MSO.ADXRibbonTab(this.components);
            this.adxRibbonGroup1 = new AddinExpress.MSO.ADXRibbonGroup(this.components);
            this.enableContactsRibbonCheckBox = new AddinExpress.MSO.ADXRibbonCheckBox(this.components);
            this.enableTasksRibbonCheckBox = new AddinExpress.MSO.ADXRibbonCheckBox(this.components);
            this.tasksAddinAdditionalModuleItem = new AddinExpress.MSO.ADXAddinAdditionalModuleItem(this.components);
            this.contactsAddinAdditionalModuleItem = new AddinExpress.MSO.ADXAddinAdditionalModuleItem(this.components);
            // 
            // adxRibbonTab1
            // 
            this.adxRibbonTab1.Caption = "My Modular Addin";
            this.adxRibbonTab1.Controls.Add(this.adxRibbonGroup1);
            this.adxRibbonTab1.Id = "adxRibbonTab_50305fa906ea4f868bfa8a3ec6d6a8ae";
            this.adxRibbonTab1.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            // 
            // adxRibbonGroup1
            // 
            this.adxRibbonGroup1.Caption = "Configuration";
            this.adxRibbonGroup1.Controls.Add(this.enableContactsRibbonCheckBox);
            this.adxRibbonGroup1.Controls.Add(this.enableTasksRibbonCheckBox);
            this.adxRibbonGroup1.Id = "adxRibbonGroup_0ee2a6e61d7247f093ae9bb147c03cbc";
            this.adxRibbonGroup1.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonGroup1.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            // 
            // enableContactsRibbonCheckBox
            // 
            this.enableContactsRibbonCheckBox.Caption = "Enable Contacts Module";
            this.enableContactsRibbonCheckBox.Id = "adxRibbonCheckBox_ebd54f2f717b4cc6bb08eccaba6e3526";
            this.enableContactsRibbonCheckBox.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            this.enableContactsRibbonCheckBox.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.enableContactsRibbonCheckBox_OnClick);
            // 
            // enableTasksRibbonCheckBox
            // 
            this.enableTasksRibbonCheckBox.Caption = "Enable Tasks Module";
            this.enableTasksRibbonCheckBox.Id = "adxRibbonCheckBox_20acd125d65c4de69fc7876b31d80f93";
            this.enableTasksRibbonCheckBox.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            this.enableTasksRibbonCheckBox.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.enableTasksRibbonCheckBox_OnClick);
            // 
            // tasksAddinAdditionalModuleItem
            // 
            this.tasksAddinAdditionalModuleItem.ModuleProgID = "TasksModule.AddinModule";
            // 
            // contactsAddinAdditionalModuleItem
            // 
            this.contactsAddinAdditionalModuleItem.ModuleProgID = "ContactsModule.AddinModule";
            // 
            // AddinModule
            // 
            this.AddinName = "MainAddIn";
            this.Modules.Add(this.tasksAddinAdditionalModuleItem);
            this.Modules.Add(this.contactsAddinAdditionalModuleItem);
            this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook;
            this.AddinStartupComplete += new AddinExpress.MSO.ADXEvents_EventHandler(this.AddinModule_AddinStartupComplete);
            this.OnRibbonBeforeCreate += new AddinExpress.MSO.ADXRibbonBeforeCreate_EventHandler(this.AddinModule_OnRibbonBeforeCreate);

        }
        #endregion

        #region Add-in Express automatic code

        // Required by Add-in Express - do not modify
        // the methods within this region

        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }

        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }

        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }

        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

        public static new AddinModule CurrentInstance
        {
            get
            {
                return AddinExpress.MSO.ADXAddinModule.CurrentInstance as AddinModule;
            }
        }

        public Outlook._Application OutlookApp
        {
            get
            {
                return (HostApplication as Outlook._Application);
            }
        }

        private void AddinModule_OnRibbonBeforeCreate(object sender, string ribbonId)
        {
            tasksAddinAdditionalModuleItem.Enabled = enableTasksRibbonCheckBox.Pressed;
            contactsAddinAdditionalModuleItem.Enabled = enableContactsRibbonCheckBox.Pressed;
        }

        private void AddinModule_AddinStartupComplete(object sender, EventArgs e)
        {
            enableContactsRibbonCheckBox.Pressed = Properties.Settings.Default.ContactsModuleEnabled;
            enableTasksRibbonCheckBox.Pressed = Properties.Settings.Default.TasksModuleEnabled;
        }

        private void enableTasksRibbonCheckBox_OnClick(object sender, IRibbonControl control, bool pressed)
        {
            Properties.Settings.Default.TasksModuleEnabled = enableTasksRibbonCheckBox.Pressed;
            Properties.Settings.Default.Save();
        }

        private void enableContactsRibbonCheckBox_OnClick(object sender, IRibbonControl control, bool pressed)
        {
            Properties.Settings.Default.ContactsModuleEnabled = enableContactsRibbonCheckBox.Pressed;
            Properties.Settings.Default.Save();
        }

    }
}

